import { Component, ViewChild } from '@angular/core';
import { NavController } from 'ionic-angular';
import { IgMapComponent, IgSplitterComponent, IgGridComponent, IgTreeComponent } from "igniteui-angular2";
import * as $ from "jquery";
import { platformBrowserDynamic }	from '@angular/platform-browser-dynamic';

declare var jQuery: any;
declare var northwindProducts: any[];
@Component({
  selector: 'page-home',
  templateUrl: 'home.html'
})
export class HomePage {
  private treeRendered: any;
  private treeSelectionChanged: any;
  private rowSelectionChanged: any;
  private expanded: any;

  private continentsWithCountriesAndCitiesCoordinates: any;

  private splitterOptions: IgSplitter;
  private mapOptions: IgMap;
  private gridOptions: IgGrid;
  private treeOptions: IgTree;
  private detailSplitterOptions: IgSplitter;

  @ViewChild("grid") grid: IgGridComponent;
  @ViewChild("map") map: IgMapComponent;
  @ViewChild("tree") tree: IgTreeComponent;
  @ViewChild("splitter") splitter: IgSplitterComponent;
  @ViewChild("detailSplitter") detailSplitter: IgSplitterComponent;

  private northwindProductsEN: any[] = [
    { "ProductID": 1, "ProductName": "Chai" }, { "ProductID": 2, "ProductName": "Chang" }, { "ProductID": 3, "ProductName": "Aniseed Syrup"}, { "ProductID": 4, "ProductName": "Chef Anton\u0027s Cajun Seasoning" },
    { "ProductID": 5, "ProductName": "Chef Anton\u0027s Gumbo Mix" }, { "ProductID": 6, "ProductName": "Grandma\u0027s Boysenberry Spread" }, { "ProductID": 7, "ProductName": "Uncle Bob\u0027s Organic Dried Pears" },
    { "ProductID": 8, "ProductName": "Northwoods Cranberry Sauce" }, { "ProductID": 9, "ProductName": "Mishi Kobe Niku" }, { "ProductID": 10, "ProductName": "Ikura" }, { "ProductID": 11, "ProductName": "Queso Cabrales", "CategoryName": "Dairy Products" },
    { "ProductID": 12, "ProductName": "Queso Manchego La Pastora" }, { "ProductID": 13, "ProductName": "Konbu" }, { "ProductID": 14, "ProductName": "Tofu" }, { "ProductID": 15, "ProductName": "Genen Shouyu" },
    { "ProductID": 16, "ProductName": "Pavlova" }, { "ProductID": 17, "ProductName": "Alice Mutton" }, { "ProductID": 18, "ProductName": "Carnarvon Tigers" }, { "ProductID": 19, "ProductName": "Teatime Chocolate Biscuits" },
    { "ProductID": 20, "ProductName": "Sir Rodney\u0027s Marmalade" }, { "ProductID": 21, "ProductName": "Sir Rodney\u0027s Scones" }, { "ProductID": 22, "ProductName": "Gustaf\u0027s Knäckebröd" }, { "ProductID": 23, "ProductName": "Tunnbröd" },
    { "ProductID": 24, "ProductName": "Guaraná Fantástica" }, { "ProductID": 25, "ProductName": "NuNuCa Nuß-Nougat-Creme" }, { "ProductID": 26, "ProductName": "Gumbär Gummibärchen" }, { "ProductID": 27, "ProductName": "Schoggi Schokolade" },
    { "ProductID": 28, "ProductName": "Rössle Sauerkraut" }, { "ProductID": 29, "ProductName": "Thüringer Rostbratwurst" }, { "ProductID": 30, "ProductName": "Nord-Ost Matjeshering" }
  ];

  constructor(public navCtrl: NavController) {
    this.continentsWithCountriesAndCitiesCoordinates = [{
      Text: "North America",
      Latitude: 46.0730555556,
      Longitude: -100.546666667,
      Countries: [{
        Text: "United States",
        Latitude: 38,
        Longitude: -97,
        Cities: [{
          Name: "Los Angeles",
          Country: "United States",
          Latitude: 34.0522,
          Longitude: -118.2434
        }, {
          Name: "New York",
          Country: "United States",
          Latitude: 40.7561,
          Longitude: -73.9870
        }, {
          Name: "Chicago",
          Country: "United States",
          Latitude: 41.840,
          Longitude: -87.680
        }, {
          Name: "Houston",
          Country: "United States",
          Latitude: 29.770,
          Longitude: -95.390
        }]
      }, {
        Text: "Canada",
        Latitude: 60,
        Longitude: -95,
        Cities: [{
          Name: "Toronto",
          Country: "Canada",
          Latitude: 43.650,
          Longitude: -79.380
        }, {
          Name: "Montreal",
          Country: "Canada",
          Latitude: 45.520,
          Longitude: -73.570
        }, {
          Name: "Vancouver",
          Country: "Canada",
          Latitude: 49.280,
          Longitude: -123.130
        }, {
          Name: "Calgary",
          Country: "Canada",
          Latitude: 51.050,
          Longitude: -114.060
        }]
      }, {
        Text: "Mexico",
        Latitude: 23,
        Longitude: -102,
        Cities: [{
          Name: "Mexico City",
          Country: "Mexico",
          Latitude: 19.4270,
          Longitude: -99.1276
        }, {
          Name: "Ecatepec",
          Country: "Mexico",
          Latitude: 19.600,
          Longitude: -99.050
        }, {
          Name: "Guadalajara",
          Country: "Mexico",
          Latitude: 20.670,
          Longitude: -103.350
        }, {
          Name: "Puebla",
          Country: "Mexico",
          Latitude: 19.050,
          Longitude: -98.220
        }]
      }]
    }, {
      Text: "South America",
      Latitude: -14.6047222222,
      Longitude: -57.6561111111,
      Countries: [{
        Text: "Brazil",
        Latitude: -10,
        Longitude: -55,
        Cities: [{
          Name: "Sao Paulo",
          Country: "Brasil",
          Latitude: -23.5489,
          Longitude: -46.6388
        }, {
          Name: "Rio de janeiro",
          Country: "Brasil",
          Latitude: -22.910,
          Longitude: -43.200
        }, {
          Name: "Salvador",
          Country: "Brasil",
          Latitude: -12.970,
          Longitude: -38.500
        }]
      }, {
        Text: "Uruguay",
        Latitude: -33,
        Longitude: -56,
        Cities: [{
          Name: "Montevideo",
          Country: "Uruguay",
          Latitude: -34.870,
          Longitude: -56.170
        }, {
          Name: "Salto",
          Country: "Uruguay",
          Latitude: -31.400,
          Longitude: -57.960
        }, {
          Name: "Ciudad de la costa",
          Country: "Uruguay",
          Latitude: -34.820,
          Longitude: -55.950
        }]
      }]
    }, {
      Text: "Europe",
      Latitude: 48.6908333333,
      Longitude: 9.14055555556,
      Countries: [{
        Text: "England",
        Latitude: 54,
        Longitude: -2,
        Cities: [{
          Name: "London",
          Country: "England",
          Latitude: 51.50,
          Longitude: 0.12
        }, {
          Name: "Glasgow",
          Country: "England",
          Latitude: 55.870,
          Longitude: -4.270
        }, {
          Name: "Birmingham",
          Country: "England",
          Latitude: 52.480,
          Longitude: -1.910
        }]
      }, {
        Text: "Germany",
        Latitude: 51,
        Longitude: 9,
        Cities: [{
          Name: "Berlin",
          Country: "Germany",
          Latitude: 52.50,
          Longitude: 13.33
        }, {
          Name: "Hamburg",
          Country: "Germany",
          Latitude: 53.550,
          Longitude: 10.000
        }, {
          Name: "Munchen",
          Country: "Germany",
          Latitude: 48.140,
          Longitude: 11.580
        }]
      }, {
        Text: "Bulgaria",
        Latitude: 43,
        Longitude: 25,
        Cities: [{
          Name: "Sofia",
          Country: "Bulgaria",
          Latitude: 42.697845,
          Longitude: 23.321925
        }, {
          Name: "Plovdiv",
          Country: "Bulgaria",
          Latitude: 42.150,
          Longitude: 24.750
        }, {
          Name: "Burgas",
          Country: "Bulgaria",
          Latitude: 42.510,
          Longitude: 27.470
        }]
      }]
    }, {
      Text: "Asia",
      Latitude: 29.8405555556,
      Longitude: 89.2966666667,
      Countries: [{
        Text: "Japan",
        Latitude: 36,
        Longitude: 138,
        Cities: [{
          Name: "Tokyo",
          Country: "Japan",
          Latitude: 35.685,
          Longitude: 139.7513889
        }, {
          Name: "Yokohama",
          Country: "Japan",
          Latitude: 35.45,
          Longitude: 139.65
        }, {
          Name: "Osaka",
          Country: "Japan",
          Latitude: 34.6666667,
          Longitude: 135.5
        }]
      }, {
        Text: "China",
        Latitude: 35,
        Longitude: 105,
        Cities: [{
          Name: "Beijing",
          Country: "China",
          Latitude: 39.92889,
          Longitude: 116.38833
        }, {
          Name: "Shanghai",
          Country: "China",
          Latitude: 31.005,
          Longitude: 121.4086111
        }]
      }]
    }];

    this.treeRendered = function(evt) {
      let unitedStatesNodeElement = evt.ui.owner.nodeByPath("0_0");
      let unitedStatesNode = evt.ui.owner.nodeFromElement(unitedStatesNodeElement);

      this.initMap();
      this.initCitiesGrid(unitedStatesNode.data.Cities);

      evt.ui.owner.expandToNode(unitedStatesNodeElement);
      evt.ui.owner.select(unitedStatesNodeElement);
    }

    this.treeSelectionChanged = function (evt) {
      var node = evt.ui.selectedNodes[0];
      this.zoomMapTo(node.data.Latitude, node.data.Longitude, 23);

      this.grid.igGrid.dataSourceObject(node.data.Cities);
      this.grid.dataBind();

      this.detailSplitter.expandAt(1);
    }

    this.expanded = function (evt) {
      $("#grid_headers").css("width", "100%");
      this.grid.widget().css("width", "100%");
    }

    this.splitterOptions = {
      height: 700,
      panels: [
        { size: 200, min: 100, max: 250 },
        { collapsible: true }
      ]
    };

    this.detailSplitterOptions = {
      orientation: "horizontal",
      panels: [
        { size: 500, collapsible: true },
        { size: 200, collapsible: true }
      ]
    };

    this.gridOptions = {
      width: "100%",
      height: "99%",
      dataSource: this.northwindProductsEN,
      defaultColumnWidth: "25%",
      features: [{
        name: "Selection",
        mode: "row",
        rowSelectionChanged: function (ui, args) {
          let selectedCity = this.grid.dataSource.dataView()[args.row.index];
          this.zoomMapTo(selectedCity.Latitude, selectedCity.Longitude, 0.5);
        }
      }]
    };

    this.mapOptions = {
      width: "100%",
      height: "100%",
      crosshairVisibility: "visible",
      overviewPlusDetailPaneVisibility: "visible",
      overviewPlusDetailPaneBackgroundImageUri: "https://www.igniteui.com/images/samples/splitter/world.png",
      panModifier: "control",
      backgroundContent: {
        type: "openStreet"
      },
      windowResponse: "immediate",
      windowRect: {
        left: 0.27,
        top: 0.20,
        height: 0.45,
        width: 0.45
      }
    }

    this.treeOptions = {
      dataSource: this.continentsWithCountriesAndCitiesCoordinates,
      dataSourceType: "json",
      bindings: {
        textKey: "Text",
        valueKey: "Text",
        childDataProperty: "Countries"
      }
    };
  }

  initMap() {
    let map = $("#map").igMap({
      width: "100%",
      height: "100%",
      crosshairVisibility: "visible",
      overviewPlusDetailPaneVisibility: "visible",
      overviewPlusDetailPaneBackgroundImageUri: "https://www.igniteui.com/images/samples/splitter/world.png",
      panModifier: "control",
      backgroundContent: {
        type: "openStreet"
      },
      windowResponse: "immediate",
      windowRect: {
        left: 0.27,
        top: 0.20,
        height: 0.45,
        width: 0.45
      }
    });
    $("#map").find(".ui-widget-content").append("<span class='copyright-notice'><a href='https://www.openstreetmap.org/copyright'>© OpenStreetMap contributors</a></span>");
    return map;
  }

  initCitiesGrid(dataSource) {
    let grid = $("#grid").igGrid({
      width: "100%",
      height: "99%",
      dataSource: dataSource,
      defaultColumnWidth: "25%",
      features: [{
        name: "Selection",
        mode: "row",
        rowSelectionChanged: function (ui, args) {
          let selectedCity =this.grid.dataSource.dataView()[args.row.index];
          this.zoomMapTo(selectedCity.Latitude, selectedCity.Longitude, 0.5);
        }
      }]
    });

    return grid;
  }

  zoomMapTo(latitude, longitude, radius) {
    let geographic = this.geographichFromCentered({
      latitude: latitude,
      longitude: longitude,
      radius: radius
    });

    let zoom = this.map.zoomToGeographic(geographic);
  }

  //  Calculates the geographich coordinates of a square around a central point and radius
  geographichFromCentered(centered) {
    let geographic = {
      left: centered.longitude - centered.radius,
      top: centered.latitude - centered.radius,
      width: centered.radius * 2,
      height: centered.radius * 2
    };

    return geographic;
  }
}



